package org.jeecg.modules.commonShopClass.service.impl;

import org.jeecg.common.exception.JeecgBootException;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.commonShopClass.entity.CommonShopClass;
import org.jeecg.modules.commonShopClass.mapper.CommonShopClassMapper;
import org.jeecg.modules.commonShopClass.service.ICommonShopClassService;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.springframework.transaction.annotation.Transactional;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * @Description: 商品分类表
 * @Author: jeecg-boot
 * @Date:   2025-05-07
 * @Version: V1.0
 */
@Service
public class CommonShopClassServiceImpl extends ServiceImpl<CommonShopClassMapper, CommonShopClass> implements ICommonShopClassService {

	@Override
	public void addCommonShopClass(CommonShopClass commonShopClass) {
	   //新增时设置hasChild为0
	    commonShopClass.setHasChild(ICommonShopClassService.NOCHILD);
		if(oConvertUtils.isEmpty(commonShopClass.getPid())){
			commonShopClass.setPid(ICommonShopClassService.ROOT_PID_VALUE);
		}else{
			//如果当前节点父ID不为空 则设置父节点的hasChildren 为1
			CommonShopClass parent = baseMapper.selectById(commonShopClass.getPid());
			if(parent!=null && !"1".equals(parent.getHasChild())){
				parent.setHasChild("1");
				baseMapper.updateById(parent);
			}
		}
		baseMapper.insert(commonShopClass);
	}
	
	@Override
	public void updateCommonShopClass(CommonShopClass commonShopClass) {
		CommonShopClass entity = this.getById(commonShopClass.getId());
		if(entity==null) {
			throw new JeecgBootException("未找到对应实体");
		}
		String old_pid = entity.getPid();
		String new_pid = commonShopClass.getPid();
		if(!old_pid.equals(new_pid)) {
			updateOldParentNode(old_pid);
			if(oConvertUtils.isEmpty(new_pid)){
				commonShopClass.setPid(ICommonShopClassService.ROOT_PID_VALUE);
			}
			if(!ICommonShopClassService.ROOT_PID_VALUE.equals(commonShopClass.getPid())) {
				baseMapper.updateTreeNodeStatus(commonShopClass.getPid(), ICommonShopClassService.HASCHILD);
			}
		}
		baseMapper.updateById(commonShopClass);
	}
	
	@Override
	@Transactional(rollbackFor = Exception.class)
	public void deleteCommonShopClass(String id) throws JeecgBootException {
		//查询选中节点下所有子节点一并删除
        id = this.queryTreeChildIds(id);
        if(id.indexOf(",")>0) {
            StringBuffer sb = new StringBuffer();
            String[] idArr = id.split(",");
            for (String idVal : idArr) {
                if(idVal != null){
                    CommonShopClass commonShopClass = this.getById(idVal);
                    String pidVal = commonShopClass.getPid();
                    //查询此节点上一级是否还有其他子节点
                    List<CommonShopClass> dataList = baseMapper.selectList(new QueryWrapper<CommonShopClass>().eq("pid", pidVal).notIn("id",Arrays.asList(idArr)));
                    if((dataList == null || dataList.size()==0) && !Arrays.asList(idArr).contains(pidVal)
                            && !sb.toString().contains(pidVal)){
                        //如果当前节点原本有子节点 现在木有了，更新状态
                        sb.append(pidVal).append(",");
                    }
                }
            }
            //批量删除节点
            baseMapper.deleteBatchIds(Arrays.asList(idArr));
            //修改已无子节点的标识
            String[] pidArr = sb.toString().split(",");
            for(String pid : pidArr){
                this.updateOldParentNode(pid);
            }
        }else{
            CommonShopClass commonShopClass = this.getById(id);
            if(commonShopClass==null) {
                throw new JeecgBootException("未找到对应实体");
            }
            updateOldParentNode(commonShopClass.getPid());
            baseMapper.deleteById(id);
        }
	}
	
	@Override
    public List<CommonShopClass> queryTreeListNoPage(QueryWrapper<CommonShopClass> queryWrapper) {
        List<CommonShopClass> dataList = baseMapper.selectList(queryWrapper);
        List<CommonShopClass> mapList = new ArrayList<>();
        for(CommonShopClass data : dataList){
            String pidVal = data.getPid();
            //递归查询子节点的根节点
            if(pidVal != null && !"0".equals(pidVal)){
                CommonShopClass rootVal = this.getTreeRoot(pidVal);
                if(rootVal != null && !mapList.contains(rootVal)){
                    mapList.add(rootVal);
                }
            }else{
                if(!mapList.contains(data)){
                    mapList.add(data);
                }
            }
        }
        return mapList;
    }
	
	/**
	 * 根据所传pid查询旧的父级节点的子节点并修改相应状态值
	 * @param pid
	 */
	private void updateOldParentNode(String pid) {
//		if(!ICommonShopClassService.ROOT_PID_VALUE.equals(pid)) {
//			Integer count = baseMapper.selectCount(new QueryWrapper<CommonShopClass>().eq("pid", pid));
//			if(count==null || count<=1) {
//				baseMapper.updateTreeNodeStatus(pid, ICommonShopClassService.NOCHILD);
//			}
//		}
	}

	/**
     * 递归查询节点的根节点
     * @param pidVal
     * @return
     */
    private CommonShopClass getTreeRoot(String pidVal){
        CommonShopClass data =  baseMapper.selectById(pidVal);
        if(data != null && !"0".equals(data.getPid())){
            return this.getTreeRoot(data.getPid());
        }else{
            return data;
        }
    }

    /**
     * 根据id查询所有子节点id
     * @param ids
     * @return
     */
    private String queryTreeChildIds(String ids) {
        //获取id数组
        String[] idArr = ids.split(",");
        StringBuffer sb = new StringBuffer();
        for (String pidVal : idArr) {
            if(pidVal != null){
                if(!sb.toString().contains(pidVal)){
                    if(sb.toString().length() > 0){
                        sb.append(",");
                    }
                    sb.append(pidVal);
                    this.getTreeChildIds(pidVal,sb);
                }
            }
        }
        return sb.toString();
    }

    /**
     * 递归查询所有子节点
     * @param pidVal
     * @param sb
     * @return
     */
    private StringBuffer getTreeChildIds(String pidVal,StringBuffer sb){
        List<CommonShopClass> dataList = baseMapper.selectList(new QueryWrapper<CommonShopClass>().eq("pid", pidVal));
        if(dataList != null && dataList.size()>0){
            for(CommonShopClass tree : dataList) {
                if(!sb.toString().contains(tree.getId())){
                    sb.append(",").append(tree.getId());
                }
                this.getTreeChildIds(tree.getId(),sb);
            }
        }
        return sb;
    }

}
